# Sample code for Hitachi Hokudai Labo and Hokkaido University Contest 2019-1 A

* This is an explanation of the sample code used in the Hitachi Hokudai Labo and Hokkaido University Contest 2019-1 A. Based on the distributed code the participants can create input samples and evaluate the score of their output on their own local machine.
* Please note that you are using the provided sample code on your own responsibility. In particular, neither Hokkaido University nor Hitachi Ltd. can be held responsible or liable, in case the execution of the provided sample code causes any damage to your computer.
* The provided program for score evaluation is identical with the program which will be used to evaluate your score during the contest. However, since the random seed used to generate the input cases during the contest may vary from your input cases, the final score of your program might vary.

## Sample code overview

The sample code is written in C++. Both the input case generator and the score
evaluation program can be found in the `scripts` subfolder.

* `generator.cpp`
    * This program generates input files for your algorithm.
* `output_checker.cpp`
    * This program scores the output of your algorithm.
* `sample_code/sample.cpp`, `sample_code/sample.py`
    * These codes are simple submissions examples to kick start contest beginners. They take care of handling the input / output communication for you. However, to make them score, you have to put your own ideas into practice.

## Compilation

For compilation of the sample code, open the scripts folder `scripts` and use
the following commands (Linux Bash).

```bash
g++ -std=gnu++11 -o generator generator.cpp
g++ -std=gnu++11 -o output_checker output_checker.cpp
```

* Note: In case the C++11 flag is ignored, there is some chance that your compiler terminates with an error.

## Generation of input samples

In order to create input files for your algorithm us the file `generator`
which was generated by compiling `generator.cpp` using the following pattern:

```bash
Usage: ./generator [filename] [case-type] [seed]
```

- `<filename>`: the name of the input file to be generated
- `<case-type>`: Specifies the type of graph
    - If `1`: Creates a graph with 200 to 400 vertices.
    - If `2`: Creates a graph with 400 vertices.
- `<seed>`: an integer which specifies a random seed

For example, creating an input file called `testcase.in` for problem A with a graph of type `1`, using the seed 2048 is done as follows:

```bash
./generator testcase.in 1 2048
```

## Scoring the output of one testcase

In order to score the output file generated by your algorithm use the file
`output_checker` which was generated by compiling `output_checker.cpp`
using the following pattern:

```bash
Usage: ./output_checker [input-filename] [output-filename]
```

`output_checker` takes two parameters

- `<input-filename>` ... name of the input file processed by your algorithm
- `<output-filename>` ... name of the output file produced by your algorithm

For example, scoring your results `result.out`, obtained by your algorithm after processing the input file `testcase.in` would result in the following execution command.

```bash
./output_checker testcase.in result.out
```

If `result.out` does not violate the output format and satisfies the output constraints, the score for this test case is send to the standard output.
